

      module system_mod
!
      contains
!
!


!
! (c) sparslab module name=realli_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli_a(ja,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli_a
!
      end subroutine realli_a
!


!

! (c) sparslab module name=reallr_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr_a(aa,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr_a
!
      i_am='reallr_a'
!      write(2,*) 'arrsize',arrsize,arrincr
      new_arrsize=arrsize+arrincr
!      write(2,*) 'arrsize',new_arrsize
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
!      write(2,*) 'arrsize',minincr,new_arrsize
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize),stat=ierr)
!      write(2,*) 'ierr',ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize),stat=ierr)
!      write(2,*) 'ierr huhu',new_arrsize,ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr_a
!
      end subroutine reallr_a
!


! (c) sparslab module name=realli3_a
!
! purpose:
!  reallocate an integer array.
!  counts with additional nlast entries.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli3_a(ja,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr,nlast
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli3_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize+nlast,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      call ivcopy_backward(nlast,ja_new,ja, &
        arrsize+1,new_arrsize+1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli3_a
!
      end subroutine realli3_a

! (c) sparslab module name=reallr3_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr3_a(aa,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,nlast,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr3_a
!
      i_am='reallr3_a'
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize+nlast,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      call dvcopy_backward(nlast,aa_new,aa, &
        arrsize+1,new_arrsize+1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr3_a
!
      end subroutine reallr3_a

!
      end module system_mod



      module matrix90
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=imhb2
!
! purpose:
!  read a sparse matrix in harwell-boeing format.
!
! history:
!   original version for sparslab - tu - 09/04/2001.
!
!
! make_explicit_interface
!
      subroutine imhb2(iunit,m,n,mformat,ia,ja,aa,info)
!
! parameters
!
      integer iunit,n,m,mformat,info
      integer, allocatable, dimension(:) :: ia,ja
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      character title*72,key*8,mxtype*3
      character ptrfmt*16,indfmt*16,valfmt*20,rhsfmt*20,rhstyp*3
      integer totcrd,ptrcrd,indcrd,valcrd,rhscrd
      integer neltvl,nrhs,nja,njas
      integer i,ierr
!
! read header
!
! -- read matrix dimensions m,n
! -- read also nja/nz but do not use it now
!
      read(iunit,1000)title,key,totcrd,ptrcrd,indcrd,valcrd,rhscrd, &
        mxtype,m,n,nja,neltvl,ptrfmt,indfmt,valfmt,rhsfmt
      if(mxtype(2:2).eq.'S'.or.mxtype(2:2).eq.'s') then
        mformat=111
      else
        mformat=12
      end if
!
!  -- read number of right-hand sides
!
      if(rhscrd.gt.0) read(iunit,1001) rhstyp,nrhs
!
!  -- read pointers
!
      allocate(ia(max(m,n)+1),stat=ierr)
      if(ierr.ne.0) go to 400
      read(iunit,ptrfmt) (ia(i),i=1,n+1)
      if(nja.ne.ia(n+1)-1) then
        stop ' internal error in harwell-boeing matrix'
      end if
!
!  -- read indices, values and close the matrix unit
!
      njas=nja
      if(mformat.eq.111) then
        njas=2*nja-n
      end if
      allocate(ja(njas+n),aa(njas+n),stat=ierr)
      if(ierr.ne.0) go to 400
      read(iunit,indfmt) (ja(i),i=1,nja)
      read(iunit,valfmt) (aa(i),i=1,nja)
!
!  -- close the matrix unit
!
      close(iunit)
!
!  -- return
!
      return
!
! -- formats
!
 1000 format(a72,a8 / 5i14 / a3, 11x, 4i14 / 2a16, 2a20)
 1001 format (a3,11x,2i14)
!
  400 continue
      info=8
      return
!
! end of imhb2
!
      end subroutine imhb2


! (c) sparslab module name=ds_eye_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
      subroutine ds_eye_mod(n,m,ia,ja,ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      len=1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod',  &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130 &
          continue
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_mod
!
      end subroutine ds_eye_mod


!
      end module matrix90



      module ptools_mod
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=aicol
! purpose:
!   modify a pivot for sparse approximate inverse preconditioner ainv,
!   invert dv1
!   get a column vector wn03/wr03(1..ind3) and scale
!   a row vector wn02/wr02(1..ind2) by dv1.
!   these operations correspond to initialization
!   before sparse rank-1 update in each step
!   of the approximate inverse preconditioner procedure
!   if diag_one=1 then scale column z_i by sqrt(pivot_i)
!
! history:
!   original version for sparslab - tu - 12/04/1996.
!
! parameters:
!
      subroutine aicol(ptc,lenc,cnc,h,wn03,wr03,ind3, &
        wr02,ind2,indexc,dv1,diagtol,imodif,diag_one)
!
! parameters
!
      implicit none
      integer :: ptc(*),lenc(*),cnc(*)
      double precision :: h(*)
      integer wn03(*)
      double precision wr02(*),wr03(*)
      double precision dv1,diagtol
      integer, intent(inout) :: ind2
      integer :: ind3,indexc,imodif
      integer diag_one
!
! internals
!
      integer istrt,istop,i
      double precision zero,temp,one
      logical never
      parameter(zero=0.0d0,one=1.0d0,never=.false.)
!
! start of aicol
!
      istrt=ptc(indexc)
      istop=istrt+lenc(indexc)-1
!
!  -- test dv1 - if dv1 too small then modify
!  -- get vector wn03/wr03(1..ind3)
!
      ind3=0
      if(dv1.lt.diagtol) then
        imodif=imodif+1
        dv1=max(abs(dv1),diagtol)
      end if
      do i=istrt,istop
        ind3=ind3+1
        wn03(ind3)=cnc(i)
        wr03(ind3)=h(i)
      end do
!
!  -- invert dv1
!
      dv1=one/dv1
!
!  -- if diag_one is set then scale pivot column
!
      if(diag_one.eq.1) then
        ind3=0
        temp=sqrt(dv1)
        dv1=temp
        do i=istrt,istop
          ind3=ind3+1
          h(i)=h(i)*temp
          wr03(ind3)=h(i)
        end do
      end if
!
!  -- scale the vector wn02/wr02(1..ind2)
!
      do i=1,ind2
        wr02(i)=wr02(i)*dv1
      end do
!
!  -- return
!
      return
!
! end of aicol
!
      end subroutine aicol



!
      end module ptools_mod



      module rank1
!
      use system_mod
      use ptools_mod
      use matrix90
!
      contains
!
!


! (c) sparslab module name=rank1n_mod_ainv
!
! purpose:
!   sparse rank-one update in dynamic data structures.
!   it updates a submatrix given by row indices
!   wn03(1..ind3) and column indices wn02(1..ind2)
!   and removes pivot column indexk and row indexj
!   from the row data structures.
!   nonsymmetric version.
!
!   vector wn03/wr03(1..ind3) corresponds to a pivot column.
!   input matrix is stored in the dynamic data structures
!   cnr,ptr,lenr/cnc,ptc,lenc
!
! history:
!   original version for sparslab - tu - 01/05/2001.
!   based on the codes sig.f, nig.f, aig.f, ainvupd1.f
!
      subroutine rank1n_mod_ainv(scrlvl,n,m,ptr,cnr,lenr, &
        max_r,ptc,cnc,lenc,h,max_c,                       &
        indexk,wr01,wn03,wr03,ind3,wn02,wr02,ind2,        &
        iendru,iendlu,drfl,nit,if2,idist,garcol,garrow,droptyp, &
        nreallocr,nreallocc)
!
! parameters
!
      implicit none
      integer n,m,droptyp,nreallocr,nreallocc,scrlvl
      integer nit,if2,max_r,max_c
      integer, allocatable :: &
        ptr(:),cnr(:),lenr(:),ptc(:),cnc(:),lenc(:)
      double precision, allocatable :: h(:)
      integer iendru,iendlu,nrow,garrow,garcol,indexk,ind2,ind3
      integer idist
      integer wn02(*),wn03(*)
      double precision wr01(*),wr02(*),wr03(*),temp
      double precision drfl
!
! internals
!
      integer istrt,istop,ibeg,ncol,i1,ierr
      integer i,j,j1,j2,j3,iqcmpr,jstrt,jstop,incr
      integer ll1,k,len,newmax_r,newmax_c,oldmax_r,oldmax_c
      double precision zero,one,drfl_rel,avg_size
      character dropping*8
      parameter (zero=0.0d0,one=1.0d0)
!
!  -- start of rank1n_mod_ainv
!
!  -- set dropping
!
      if(droptyp.eq.0) then
        dropping='absolute'
      elseif(droptyp.eq.1) then
        dropping='relative'
      end if
!
!  -- define new parameters
!
      ibeg=1
!
!  -- remove indexk from the rows
!  -- which intersect column indexk.
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        k=cnc(i)
        jstrt=ptr(k)
        jstop=jstrt+lenr(k)-1
        do j=jstrt,jstop
          if(cnr(j).eq.indexk) then
            cnr(j)=cnr(jstop)
            cnr(jstop)=0
            lenr(k)=lenr(k)-1
            go to 25
          end if
        end do
 25  &
        continue
      end do
!
!  -- main loop for columns with indices from wn02(1..ind2)
!
      do ll1=1,ind2
!
!    -- get index of the updated column and
!    -- corresponding column value of the rank-1 matrix
!
        ncol=wn02(ll1)
        temp=wr02(ll1)
!
!    -- scatter and scale the pivot column from wr03 into wr01
!
        do i=1,ind3
          j=wn03(i)
          wr01(j)=-wr03(i)*temp
        end do
!
!    -- define start and end of the column ncol
!
        istrt=ptc(ncol)
        istop=istrt+lenc(ncol)-1
!
!    -- compute average size of an original nonzero
!    -- for relative dropping
!
        if(dropping.eq.'relative') then
          avg_size=zero
          do j=istrt,istop
            temp=h(j)
            avg_size=avg_size+abs(temp)
          end do
          len=istop-istrt+1
          if(len.ne.0) then
            avg_size=avg_size/dble(len)
          end if
        end if
!
!    -- get drop tolerance
!
        if(dropping.eq.'relative') then
          drfl_rel=drfl*avg_size
        else
          drfl_rel=drfl
        end if
!
!    -- update existing entries of the column ncol
!
        do j=istrt,istop
          k=cnc(j)
          if(wr01(k).ne.zero) then
!
!        -- update
!
            h(j)=h(j)+wr01(k)
            wr01(k)=zero
            if(abs(h(j)).lt.drfl_rel.and.k.ne.ncol) then
!
!          -- mark the value which is to be dropped
!
              cnc(j)=0
!
!          -- define start and end of the corresponding row list
!
              jstrt=ptr(k)
              jstop=jstrt+lenr(k)-1
!
!          -- find index ncol in the row list corresponding
!          -- to an entry to be dropped
!
              do i1=jstrt,jstop
                if(cnr(i1).eq.ncol) then
!
!              -- index found
!
                  cnr(i1)=cnr(jstop)
                  cnr(jstop)=0
                  lenr(k)=lenr(k)-1
!
!              -- jump outside
!
                  go to 204
                end if
              end do
 204 &
              continue
            end if
          end if
        end do
!
! -- remove marked candidates to be dropped
! -- shrink remaining entries in the column ncol between
! -- istrt and istop
!
        i=istrt
        do j=istrt,istop
          if(cnc(j).eq.0) then
            if2=if2-1
            go to 220
          else
            cnc(i)=cnc(j)
            h(i)=h(j)
            i=i+1
          end if
 220 &
          continue
        end do
        lenc(ncol)=i-istrt
        do j=i,istop
          cnc(j)=0
        end do
        istop=i-1
!
!    -- insert fill-in into column ncol
!
        do 80 i=1,ind3
          nrow=wn03(i)
!
!      -- test fill-in size
!
          if(abs(wr01(nrow)).gt.drfl_rel) then
!
!        -- look for a free space at the beginning of a column list
!
            if(istrt.gt.1) then
              if(cnc(istrt-1).eq.0) then
!
!            -- add a the new entry at the beginning of the column list
!
                istrt=istrt-1
                cnc(istrt)=nrow
                h(istrt)=wr01(nrow)
                lenc(ncol)=lenc(ncol)+1
                ptc(ncol)=ptc(ncol)-1
                if2=if2+1
                go to 550
              end if
            endif
!
!        -- look for a free space at the end of a column list
!
 400 &
            continue
            if(cnc(istop+1).eq.0) then
!
!          -- add a new element at the end of a column list
!
              iqcmpr=0
              istop=istop+1
              cnc(istop)=nrow
              h(istop)=wr01(nrow)
              if2=if2+1
              iendlu=max(iendlu,istop)
              lenc(ncol)=lenc(ncol)+1
            else
              j1=istop-istrt+1
              if((iendlu+j1).lt.max_c-1) then
!
!            -- copy a column at the current end
!            -- of the column working space
!
                j2=istrt-1-iendlu
                do j=iendlu+1,iendlu+j1
                  j3=j2+j
                  cnc(j)=cnc(j3)
                  h(j)=h(j3)
                  cnc(j3)=0
                end do
                iqcmpr=0
                istrt=iendlu+1
                ptc(ncol)=istrt
                istop=iendlu+j1
                cnc(istop+1)=0
                go to 400
              else
!
!            -- garbage collection of the column working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendlu)/dble(nit))*dble(n).gt.max_c) then
!
!              -- reallocation of cnc,h
!
                  oldmax_c=max_c
                  incr=min(max_c,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnc,max_c,incr,newmax_c,ierr)
                  call reallr_a(h,max_c,incr,newmax_c,ierr)
                  max_c=newmax_c
                  nreallocc=nreallocc+1
                  call iwset1(max_c-oldmax_c+1,0,cnc,1,oldmax_c)
                  cnc(max_c)=1
                end if
                iqcmpr=1
                garcol=garcol+1
                if(scrlvl.gt.0) then
                  write(*,*) ' column garbage collection no.',garcol
                end if
                call garclds(n,ptc,cnc,lenc,h,max_c, &
                  ibeg,iendlu,nit,idist)
                istrt=ptc(ncol)
                istop=istrt+lenc(ncol)-1
                go to 400
              end if
            end if
 550 &
            continue
!
!        -- add a new index ncol into a row list corresponding to
!        -- the new fill-in position nrow
!
            jstrt=ptr(nrow)
            jstop=jstrt+lenr(nrow)-1
!
!        -- look for a free space at the beginning of a row list
!
            if(jstrt.gt.1) then
              if(cnr(jstrt-1).eq.0) then
!
!            -- add a new element at the beginning of a row list
!
                jstrt=jstrt-1
                cnr(jstrt)=ncol
                lenr(nrow)=lenr(nrow)+1
                ptr(nrow)=ptr(nrow)-1
                go to 450
              end if
            endif
!
!          -- look for a free space at the end of a row list
!
 440 &
            continue
            if(cnr(jstop+1).eq.0) then
!
!          -- add a new element at the end of a row list
!
              iqcmpr=0
              jstop=jstop+1
              cnr(jstop)=ncol
              iendru=max(iendru,jstop)
              lenr(nrow)=lenr(nrow)+1
            else
!
!          -- copy a row at the current end of the row working space
!
              j1=jstop-jstrt+1
              i1=jstrt-1-iendru
              if((iendru+j1).lt.max_r-1) then
                do j2=1+iendru,j1+iendru
                  j3=i1+j2
                  cnr(j2)=cnr(j3)
                  cnr(j3)=0
                end do
                iqcmpr=0
                jstrt=iendru+1
                ptr(nrow)=jstrt
                jstop=iendru+j1
                cnr(jstop+1)=0
                go to 440
              else
!
!            -- garbage collection of the row working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendru)/dble(nit))*dble(n).gt.max_r) then
!
!              -- reallocation of cnr
!
                  oldmax_r=max_r
                  incr=min(max_r,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnr,max_r,incr,newmax_r,ierr)
                  max_r=newmax_r
                  nreallocr=nreallocr+1
                  call iwset1(max_r-oldmax_r+1,0,cnr,1,oldmax_r)
                  cnr(max_r)=1
                end if
                iqcmpr=1
                garrow=garrow+1
                if(scrlvl.gt.0) then
                  write(*,*) ' row garbage collection no.',garrow
                end if
                call garclds2(m,ptr,cnr,lenr,max_r,ibeg, &
                  iendru,idist)
                jstrt=ptr(nrow)
                jstop=jstrt+lenr(nrow)-1
                go to 440
              end if
            end if
 450 &
            continue
          end if
!
!      -- clear nrow position in wr01
!
          wr01(nrow)=zero
!
!      -- end of fill-in cycle
!
 80  &
        continue
!
!   -- end of loop for columns
!
      end do
!
!  -- return
!
      return
!
! end of rank1n_mod_ainv
!
      end subroutine rank1n_mod_ainv



!
      end module rank1



      module ainv90
!
      use system_mod
      use ptools_mod
      use matrix90
      use rank1
!
      contains
!
!


! (c) sparslab module name=ainvsl3
!
! purpose:
!  symmetric left-looking ainv stabilized preconditioner construction.
!  factorized approximate inverse is in the form: a^{-1}=z^t*d^{-1}*z,
!  where z is the lower triangular matrix stored by rows.
!  with respect to ainvsl2 it uses one additional auxiliary vector and
!  it has slightly lower number of non-float operations.
!
!       | *  *  .  .  .  |   | *              |   | *              |
!       |    *  .  .  ^  |   |    *           |   | *  *           |
!       |       *  .  |  | * |       *        | * | .  .  *        |
!       |          *  |  |   |          *     |   | .  .  .  *     |
!       |             *  |   |             *  |   | .  ---->    *  |
!
! A^{-1} =     Z^T        *         D^{-1}     *         Z
!
! history:
!   original version for sparslab - tu - 3/5/1999.
!
! references:
!   benzi/cullum/tuma, 1999
!
! parameters:
!
!
! make_explicit_interface
!
      subroutine ainvsl3(msglvl,msgunit,            &
        n,ia,ja,aa,iz,jz,az,max_z,diag,             &
        diagtol,drfl,imodif,diag_one,droptyp,fill,  &
        maxznorm,minznorm,maxdiag,mindiag,info)
!
! parameters
!
      integer msglvl,msgunit,n,max_z
      integer ia(*),ja(*)
      double precision aa(*)
      integer, allocatable :: iz(:),jz(:)
      double precision, allocatable :: az(:),diag(:)
      double precision diagtol,drfl
      integer imodif
      integer droptyp,diag_one
      integer fill,info
      double precision maxdiag,mindiag,maxznorm,minznorm
!
! internals
!
      integer, allocatable :: wn01(:),wn02(:),wn03(:)
      integer, allocatable :: wia0(:),wn04(:),wn05(:)
      double precision, allocatable :: wr02(:),wr03(:)
      integer, allocatable :: jz_new(:)
      double precision, allocatable :: az_new(:)
!
      double precision zero,one
      parameter (zero=0.0d0,one=1.0d0)
      integer i,j,k,l,ii,ind2,ind3,istrt,istop,ind4
      integer iendlu,ind,jstrt,jstop
      integer lastind,nexti,kk,nflag
      integer tagbase,tag
      integer nit
      double precision pi1,pi2,pi3
      double precision temp1
      double precision dv1,pi2x3
      double precision znorm
      integer maxtag,ierr
      parameter(maxtag=2000000000)
      character dropping*8
!
! start of ainvsl3
!
      maxznorm=zero
      minznorm=one
      maxdiag=zero
      mindiag=one
      info=0
!
!  -- allocation
!
      allocate(wn01(n+1),wn02(n+1),wn03(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wia0(n+1),wn04(n+1),wn05(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wr02(n+1),wr03(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- allocate reallocatables
!
      allocate(iz(n+1),jz(max_z),az(max_z),diag(n),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- initialization
!
      info=0
      imodif=0
      if(droptyp.eq.0) then
        dropping='absolute'
      elseif(droptyp.eq.1) then
        dropping='relative'
      end if
      nflag=n+1
      call iwset(n,nflag,wn01,1)
      call iwset(n,0,wn04,1)
      call iwcopy(n,ia,1,wia0,1)
      iendlu=0
      iz(1)=1
      nit=1
      tagbase=0
      wr02(nflag)=zero
!
!  -- echo
!
      if(msglvl.ge.2) write(*,*) &
            ' symmetric left looking approximate inverse biconjugation'
!
!  -- left-looking loop to compute
!     z_{nit}^{nit-1} =
!       z_{nit}^{(0)} - sum_{i=1}^{nit-1}
!                         [(p_{nit}^{(i-1)}/p_i^{(i-1)} z_i^{(i-1)}
!
!  -- jump label
!
 4933 &
       continue
!
      lastind=0
      ind3=0
!
!  -- -- set initial nit-th basis column
!        z_{nit}^{(0)}=e_{nit}
!
      ind2=1
      wn02(ind2)=nit
      wr02(ind2)=one
      wn01(nit)=ind2
      nexti=nit
!
!  -- -- find the next column of z updating z_{nit}^{(*)}
!
 19  &
       continue
      nexti=nit
      do ii=1,ind2
        j=wn02(ii)
        k=wia0(j)
 22  &
        continue
        if(k.ge.ia(j+1)) then
          wia0(j)=k
        else
          kk=ja(k)
          if(kk.le.lastind) then
            l=ia(j)
            if(k.eq.l) then
              ind3=ind3+1
              wn03(ind3)=j
            end if
            k=k+1
            go to 22
          end if
          wia0(j)=k
          if(kk.lt.nexti) nexti=kk
        end if
      end do
!
      if(nexti.lt.nit) then
!
!    -- -- do the stabilized update using the formulas
!       p_{nit}^{(i-1)} = z_i^{(i-1)}^t*a*z_{nit}^{(i-1)} and
!       p_i^{(i-1)} = z_i^{(i-1)}^t*a*z_i^{(i-1)}
!
!
!    -- -- -- compute into pi2
!             p_{nit}^{(i-1)} = z_i^{(i-1)}^t*a*z_{nit}^{(i-1)}
!
        ind4=0
        tag=tagbase+nexti
        do i=1,ind2
          ii=wn02(i)
          jstrt=ia(ii)
          jstop=ia(ii+1)-1
          do j=jstrt,jstop
            k=ja(j)
            l=wn04(k)
            if(l.ne.tag) then
              ind4=ind4+1
              wr03(ind4)=wr02(i)*aa(j)
              wn04(k)=tag
              wn05(k)=ind4
            else
              l=wn05(k)
              wr03(l)=wr03(l)+wr02(i)*aa(j)
            end if
          end do
        end do
!
        pi2=zero
        jstrt=iz(nexti)
        jstop=iz(nexti+1)-1
        do j=jstrt,jstop
          ii=jz(j)
          k=wn04(ii)
          if(k.eq.tag) then
            kk=wn05(ii)
            pi2=pi2+wr03(kk)*az(j)
          end if
        end do
!
!  -- -- -- distinguish square-root and non-square-root algorithm
!
        if(diag_one.eq.1) then
          pi2x3=pi2
!          pi2=pi2/diag(nexti)
        else
          pi3=diag(nexti)
          pi2x3=pi2*pi3
        end if
!
!    -- the sparse saxpy update
!
        istrt=iz(nexti)
        istop=iz(nexti+1)-1
!
!  -- -- -- -- substract and compute fill-in
!
        ind=0
        do i=istrt,istop
          j=jz(i)
          k=wn01(j)
          if(k.ne.nflag) then
            temp1=wr02(k)-pi2x3*az(i)
            wr02(k)=temp1
          else
            temp1=-pi2x3*az(i)
          end if
          ind=ind+1
          wr03(ind)=temp1
        end do
!
!  -- -- -- -- scan and drop elements of wr02
!
        ind=1
        do i=2,ind2
          temp1=wr02(i)
          j=wn02(i)
          if(abs(temp1).ge.drfl) then
            ind=ind+1
            wr02(ind)=temp1
            wn02(ind)=j
            wn01(j)=ind
          else
            wn01(j)=nflag
          end if
        end do
        ind2=ind
!
!  -- -- -- -- add the fill-in
!
        ind=0
        do i=istrt,istop
          ind=ind+1
          j=jz(i)
          k=wn01(j)
          if(k.eq.nflag) then
            temp1=wr03(ind)
            if(abs(temp1).ge.drfl) then
              ind2=ind2+1
              wr02(ind2)=temp1
              wn02(ind2)=j
              wn01(j)=ind2
            end if
          end if
        end do
!
!  -- -- set the lower bound for the search
!
        lastind=nexti
        go to 19
      end if
!
!  -- -- reset the starting search pointers
!
      do i=1,ind3
        j=wn03(i)
        wia0(j)=ia(j)
      end do
!
!  -- get the nit-th diagonal element
!
!  -- -- compute into pi2
!        p_{nit}^{(nit-1)} = z_{nit}^{(nit-1)}^t*a*z_{nit}^{(nit-1)}
!
      ind3=0
      tag=tagbase+nit
      if(tag.ge.maxtag) then
        call iwset(n,0,wn04,1)
        tagbase=0
        tag=nit
      end if
      do i=1,ind2
        ii=wn02(i)
        jstrt=ia(ii)
        jstop=ia(ii+1)-1
        do j=jstrt,jstop
          k=ja(j)
          l=wn04(k)
          if(l.ne.tag) then
            ind3=ind3+1
            wr03(ind3)=wr02(i)*aa(j)
            wn04(k)=tag
            wn05(k)=ind3
          else
            kk=wn05(k)
            wr03(kk)=wr03(kk)+wr02(i)*aa(j)
          end if
        end do
      end do
!
      pi1=zero
      do i=1,ind2
        j=wn02(i)
        k=wn04(j)
        if(k.eq.tag) then
          kk=wn05(j)
          pi1=pi1+wr03(kk)*wr02(i)
        end if
      end do
      dv1=pi1
!
!  -- test the diagonal element dv1
!  -- dv1 should be nonnegative and sufficiently large
!
      if(dv1.lt.diagtol) then
        imodif=imodif+1
        temp1=abs(dv1)
        dv1=max(temp1,diagtol)
      end if
      write(47,*) dv1
      maxdiag=max(dv1,maxdiag)
      mindiag=min(dv1,mindiag)
!
!  -- column scaling in case of square-root algorithm
!
      znorm=zero
      if(diag_one.eq.1) then
        temp1=one/sqrt(dv1)
        dv1=temp1
        do i=1,ind2
          znorm=znorm+wr02(i)*wr02(i)
          wr02(i)=temp1*wr02(i)
        end do
        diag(nit)=temp1
      else
        diag(nit)=one/dv1
      end if
      znorm=max(zero,znorm)
      znorm=sqrt(znorm)
      maxznorm=max(znorm,maxznorm)
      minznorm=min(znorm,minznorm)
!
!  -- column copy
!
      ind=iendlu
      iendlu=iendlu+ind2
      if(iendlu.ge.max_z) then
        max_z=iendlu
        max_z=max_z+min(max_z,(n*n+1-nit*(nit-1))/2)
        allocate(az_new(ind),stat=ierr)
        if(ierr.ne.0) go to 400
        az_new(1:ind)=az(1:ind)
        deallocate(az)
        allocate(az(max_z),stat=ierr)
        if(ierr.ne.0) go to 400
        az(1:ind)=az_new(1:ind)
        deallocate(az_new)
        allocate(jz_new(ind),stat=ierr)
        if(ierr.ne.0) go to 400
        jz_new(1:ind)=jz(1:ind)
        deallocate(jz)
        allocate(jz(max_z),stat=ierr)
        if(ierr.ne.0) go to 400
        jz(1:ind)=jz_new(1:ind)
        deallocate(jz_new)
      end if
      do i=1,ind2
        ind=ind+1
        j=wn02(i)
        jz(ind)=j
        az(ind)=wr02(i)
        wn01(j)=nflag
      end do
      iz(nit+1)=ind+1
      fill=ind
!
!  -- echo
!
      if(msglvl.ne.0) then
        if(msglvl.eq.2) then
          if(nit/100.eq.dble(nit)/100.0d0) then
            if(msgunit.eq.0) then
              write(*,*)' nit =',nit, ' fill = ',fill
            elseif(msgunit.gt.0) then
              write(msgunit,*)' nit =',nit, ' fill = ',fill
            end if
          end if
        elseif(msglvl.ge.3) then
          if(msgunit.eq.0) then
            write(*,*)' nit =',nit, ' fill = ',fill
          elseif(msgunit.gt.0) then
            write(msgunit,*)' nit =',nit, ' fill = ',fill
          end if
        end if
      end if
!
!  -- test the end and update tag base
!
      if(nit.lt.n) then
        nit=nit+1
        tagbase=tagbase+n
        go to 4933
      end if
!
!  -- deallocation
!
      deallocate(wn01,wn02,wn03,wia0,wn04,wn05,wr02,wr03)
!
!  -- return
!
      return
!
  400 continue
      info=8
      return
!
! end of ainvsl3
!
      end subroutine ainvsl3


!
      end module ainv90

